﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.5
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Public currentable As String
	Public name As String = "gestdatiarc"
	Private vm As BANanoVM
	Private BANano As BANano  'ignore
	Private vue As BANanoVue
	Public lnamecol As List
	Public ltypecol As List
	Private dt1 As VMDataTable
End Sub

Public Sub Code
	vm = pgIndex.vm
	vue = vm.vue
	Dim cont As VMContainer = vm.CreateContainer(name, Me)
	'hide this container
	cont.Hide
	'
	cont.AddRows(5).AddColumns12
	'
	dt1 = vm.CreateDataTable("dt1", "name", Me)
	'dt1.SetTitle("?")
	dt1.AddSearch
	dt1.AddDivider
	dt1.AddNew("btnNew", "mdi-plus", "Add a new record")
	dt1.AddDivider
	dt1.SetClearSort
	dt1.SetItemsperpage("10")
	dt1.SetPage("1")
	dt1.SetMultiSort(True)
	'NB: Add action buttons, these are based on templates and should be pre-defined
	dt1.AddEditThrash
	'dt1.AddDownload
	'dt1.AddMenuV
	'dt1.AddClone
	'dt1.AddPrint
	dt1.SetExternalPagination
	dt1.SetCalculateWidths(True)
	dt1.SetOnInput("dt1_input")
	dt1.SetIconDimensions("edit", "32px", "success")
	dt1.SetIconDimensions("delete", "32p", "error")
	dt1.AddToContainer(cont, 1, 1)
	'
	'add container to page
	vm.AddContainer(cont)
	'register the sub routine
	vm.SetMethod(Me, "LoadDatitb")
End Sub


'show the page and hide all others
Sub Show
	'the navbar is visible for this page
	vm.NavBar.Show
	'show the hamburger for this page
	vm.NavBar.Hamburger.SetVisible(True)
	'the drawer should be hidden for this page
	vm.Drawer.Show
	'the logo should be visible for this page
	vm.NavBar.Logo.Show
	'2. Show the page and hide others
	vm.ShowPage(name)
	'call the method
	vm.CallMethod("LoadDatitb")
End Sub

Sub LoadDatitb
	'get the table name from the state
	currentable = vm.getdata("currentable")
	If currentable = "" Then Return
	vm.PagePause
	'vm.ShowLoading
	'update the table title
	lnamecol.Clear
	ltypecol.Clear
	Dim dbSchema As BANanoMySQLE
	dbSchema.Initialize(pgIndex.db, "", "", "")
	dbSchema.Execute($"DESCRIBE ${currentable.ToUpperCase}"$)
	dbSchema.json = BANano.CallInlinePHPWait(dbSchema.MethodName, dbSchema.Build)
	dbSchema.FromJSON
	If dbSchema.OK = False Then
		vm.ShowSnackBarError(dbSchema.error)
		'vm.HideLoading
		vm.PageResume
		Return
	End If
	For Each fld As Map In dbSchema.Result
		lnamecol.Add(fld.Get("Field"))
		ltypecol.add(fld.Get("Type"))
	Next
	'define a new variable for records to avoid conflicts
	Dim dbRecords As BANanoMySQLE
	dbRecords.Initialize(pgIndex.db, "", "", "")
	dbRecords.Execute($"SELECT * FROM ${currentable}"$)
	dbRecords.json = BANano.CallInlinePHPWait(dbRecords.MethodName, dbRecords.Build)
	dbRecords.FromJSON
	'reset everything about the table
	dt1.Reset
	'add the new columns
	For Each colName As String In lnamecol
		dt1.AddColumn(colName, colName)
	Next
	'ensure the action buttons are visible
	dt1.AddEditThrash
	'dt1.AddDownload
	'dt1.AddMenuV
	'dt1.AddClone
	'dt1.AddPrint
	'build the new columns
	dt1.ResetColumns
	dt1.UpdateTitle(currentable.ToUpperCase)
	'set the items of the table
	dt1.SetDataSource(dbRecords.result)
	'vm.HideLoading
	vm.PageResume
End Sub


Sub GetNumRec As String
	Dim dbsql As BANanoMySQLE
	dbsql.Initialize(pgIndex.db, "", "", "")
	'dbsql.SetConnection(pgIndex.dbhost, pgIndex.user, pgIndex.pass)
	dbsql.query = $"SELECT COUNT(*) FROM ${currentable}"$
	dbsql.Execute(dbsql.query)
	dbsql.json = BANano.CallInlinePHPWait(dbsql.MethodName, dbsql.Build)
	dbsql.FromJSON
	Dim m As Map = dbsql.result.Get(0)
	Return m.get("COUNT(*)")
End Sub